package com.ibm.sysmgt.raidmgr.cim.provider.association;

import com.ibm.sysmgt.raidmgr.cim.provider.instance.*;

import java.io.*;
import java.util.*;
import java.rmi.RemoteException;

import com.sun.wbem.cim.*;
import com.sun.wbem.provider20.AssociatorProvider;

import com.ibm.sysmgt.raidmgr.dataproc.config.*;
import com.ibm.sysmgt.raidmgr.util.*;

public class AssociatorRAIDArray extends RAIDAssociatorProviderBase
{
   public AssociatorRAIDArray()
   {
      super("AssociatorRAIDArray:", "IBMPSG_AssociatedRAIDArray");
      associationLog.println(logHeader + "AssociatorRAIDArray()");
   }

   protected Vector associatorHelper(CIMObjectPath assocName, CIMObjectPath objectName, String resultClass, 
                                 String role, String resultRole) throws CIMException
   {
      return new Vector();
   }


   protected Vector referenceHelper(CIMObjectPath assocName, CIMObjectPath objectName, String role) throws CIMException
   {
      return new Vector();
   }

   //**************************************************************************************************************
   // Now for the InstanceProvider implementation (for Windows)
   //**************************************************************************************************************
   public Vector enumInstances(CIMObjectPath op, boolean deep, CIMClass cc, boolean localOnly) throws CIMException
   {
      associationLog.println(logHeader + "enumInstances(" + op.getObjectName() + ")");

      if (!op.getObjectName().trim().equalsIgnoreCase(CIM_CREATION_CLASS_NAME))
      {
         associationLog.println(logHeader + "Does not provide instances of class " + op.getObjectName());         
         throw (new CIMException(CIMException.CIM_ERR_NOT_SUPPORTED));
      }

      
      
      Vector instances = new Vector();

      RaidSystem system = null;
      try
      {         
         system = (RaidSystem)getRaidSystem();
      }
      catch (RemoteException e)
      {
         associationLog.println(logHeader + "Error accessing the ServeRAID Manager agent. Exception: " + e);
         
         throw new CIMException(CIMException.CIM_ERR_FAILED);
      }

      for (Enumeration e = system.enumerateAdapters(); e.hasMoreElements();)
      {         
         Adapter adapter = (Adapter)e.nextElement();
         for (Enumeration e2 = adapter.getArraysContainer().enumerateArrays(); e2.hasMoreElements();)
         {            
            Array array = (Array)e2.nextElement();
            instances.addElement(array.createAssociatedRAIDArrayAssociation(cc.newInstance()));

            if (array instanceof SpannedArray)
            {
               for (Enumeration e3 = ((SpannedArray)array).enumerateArrays(); e3.hasMoreElements();)
               {
                  BasicArray basicArray = (BasicArray)e3.nextElement();
                  instances.addElement(basicArray.createAssociatedRAIDArrayAssociation(cc.newInstance()));
               }
            }
         }         
      }

      

      return instances;
   }

   public Vector enumInstances(CIMObjectPath op, boolean deep, CIMClass cc) throws CIMException
   {
      associationLog.println(logHeader + "enumInstances(" + op.getObjectName() + ") Names Only");

      Vector instances = enumInstances(op, deep, cc, true);
      Vector cops = new Vector();

      for (Enumeration e = instances.elements(); e.hasMoreElements();)
      {
         CIMInstance ci = (CIMInstance)e.nextElement();
         CIMObjectPath cop = new CIMObjectPath(cc.getName(), op.getNameSpace());
         cop.setKeys(ci.getKeyValuePairs());
         cops.addElement(cop);
      }

      return cops;
   }
}
