/**
 * Title:        IBMSG ServeRAID Diagnostic Provider
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      IBM
 * Iniial Date:  August 30, 2001 
 *
 * @author Rodney H. Brown
 * Path, component, release: prov/com/ibm/providers/ServeRAID/IBMSG_ServeRAIDTest.java, sv_esw_cdm_provider, raid_prov, 20021101
 * Version                 : 1.12
 * Extracted at            : 10:44:45 on 11/12/02
 * Newest delta applied at : 10:15:09 on 10/30/02
 * Notes:
 *  
 * Change History:
 *   Date:                      Intials/Defect          Change:
 *   09102001                   RHB                     Update provider code to the latest levels
 *   11052001                   RHB176259               Modify test names to reflect action items
 */

//$$$ cahnge package name to be same as proivider package
package com.ibm.sysmgt.raidmgr.cim.provider.cdm;


import com.sun.wbem.cim.*;
import com.sun.wbem.client.*;
import java.util.*;
import com.ibm.CDMProvider.*;





/**
 * This class contains the test specific information and methods. 
 * Change the data and the methods but DO NOT change the variable and method names 
 */
//$$$ Change the class name but not the parent class
public class IBMSG_ServeRAIDTest extends IBMSG_TestInfo
{
   public static final String namespace = "root/cimv2";



    /**
     *  Constructor
     */
    //$$$ cahnge the constructor name
    public IBMSG_ServeRAIDTest()
    {
    }



    //### method to make sure test cases are on machine???



    /**
     *  Method to return the number of tests
     */
    public int getNumberOfTests()
    {
        int numberoftests = Name.length;
        return  numberoftests;
    }



    /**   
     *  this method returns the index number of the test name passed in
     */
    public int getTestIndex (String testname)
    {
        int i;
        for (i = 0; i < Name.length ; i++)
        {
            if (Name[i].equalsIgnoreCase(testname))
                return i;
        }

        return i =0xFF;  // do not know this tedst name
    }




    /**
     * this method return the index number of the test from the name property
     * of the object path paseed in
     *
     * currently supports the dt.Name and res.DiagnosticName properties  
     */
    public int getTestIndex(CIMObjectPath cop, String propname)
    {
        //DEBUG_PRINT("         In getdtindex for cop "+cop+"\n");
        int idx = 0xFF;

        
        if (!(propname.equalsIgnoreCase("Name") ||
                       propname.equalsIgnoreCase("DiagnosticName")))
        {
            // return prop not supported 
            return idx;
        }

        // get the keys from the CIMObjectPath
        Vector keys = cop.getKeys();
        //DEBUG_PRINT("         keys are: "+keys+"\n");
        // find the property "Name"
        CIMProperty key = null;
        for (int i=0; i<keys.size(); i++)
        {
            key = (CIMProperty)keys.elementAt(i);
            //DEBUG_PRINT("         key is: "+key+"\n");
            if (propname.equalsIgnoreCase(key.getName()))
            {
                //DEBUG_PRINT("            found Name key\n");
                break;
            }
        }

        // get property value which is the test name
        String strval = (String)(key.getValue().getValue());
        //DEBUG_PRINT("            strval is: "+strval+"\n");

        return idx = getTestIndex(strval);
    }


    
    /**
     * Method just to satisfy compiler
     */
    public String getName(int index)
    {
        String x = "";
        return x;
    }

    /**
     *  Method to return test name based on the index passed in
     */
    public String getTestName(int index)
    {
        return  Name[index];
    }



    /**
     *  Method to return the Caption (String)
     */
    public CIMValue getCaption(int index)
    {
        CIMValue cvCaption = new CIMValue(Caption[index]);
        return  cvCaption;
    }



    /**
     *  Method to return the descriptions (String)
     */
    public CIMValue getDescription()
    {
        CIMValue cvDescription = new CIMValue(Description);
        return  cvDescription;
    }



    /**
     *  Method to return the device status (String)
     */
    public CIMValue getStatus()
    {
//### ToDo - All call should be made to the device class to get this property
        CIMValue cvStatus = new CIMValue(Status);
        return  cvStatus;
    }



    /**
     *  Method to return if the test is started (boolean)
     */
    public CIMValue getStarted(int index)
    {
        CIMValue cvStarted;

        if (Started[index] == false)
            cvStarted = new CIMValue(Boolean.FALSE);
        else
            cvStarted = new CIMValue(Boolean.TRUE);

        return  cvStarted;
    }



    /**
     *  Method to return how the test is invoked (String)
     */
    public CIMValue getStartMode()
    {
        CIMValue cvStartMode = new CIMValue(StartMode);
        return  cvStartMode;
    }



    /**
     *  Method to return if the test is currently in use (boolean)
     */
    public CIMValue getIsInUse(int index)
    {
        CIMValue cvIsInUse;

        if (IsInUse[index] == false)
            cvIsInUse = new CIMValue(Boolean.FALSE);
        else
            cvIsInUse = new CIMValue(Boolean.TRUE);

        return  cvIsInUse;
    }



    /**
     *  Method to return the system resources the test uses (UINT16_ARRAY)
     */
    public CIMValue getResourcesUsed(int index)
    {
        Vector v = new Vector();
        CIMValue cvResourcesUsed;
        int x = 0;

        while (ResourcesUsed[index][x] != 0xFF)
        {
            v.addElement(new UnsignedInt16(ResourcesUsed[index][x]));
            x++;
        }

        cvResourcesUsed = new CIMValue(v,
                      CIMDataType.getPredefinedType(CIMDataType.UINT16_ARRAY));

        return  cvResourcesUsed;
    }


   
    
    /**
     *  Method to return the test characeristics (UINT16_ARRAY)
     */
    public CIMValue getCharacteristics(int index)
    {
        Vector v = new Vector();
        CIMValue cvCharacteristics;
        int x = 0;

        while (Characteristics[index][x] != 0xFF)
        {
            v.addElement(new UnsignedInt16(Characteristics[index][x]));
            x++;
        }

        cvCharacteristics = new CIMValue(v,
                      CIMDataType.getPredefinedType(CIMDataType.UINT16_ARRAY));


        return  cvCharacteristics;
    }




    /**
     *  Method to return if the test is currentlu in use (String)
     */
    public CIMValue getOtherCharacteristicDescription(int index)
    {
        CIMValue cvOtherCharacteristicDescription =
                                new CIMValue(OtherCharacteristicDescription[index]);
        return  cvOtherCharacteristicDescription;
    }



    public CIMValue getEstimatedTimeOfPerforming(int index)
    {
        CIMValue cvEstimatedTimeOfPerforming;

        cvEstimatedTimeOfPerforming =
                      new CIMValue(new UnsignedInt32(EstimatedTimeOfPerforming[index]));

        return cvEstimatedTimeOfPerforming;
    }



    /**
     *  Method to return if the test is Exclusive For MSE (boolean)
     *  means it can only run on one MSE at a time
     */
    public CIMValue getIsExclusiveForMSE(int index)
    {
        CIMValue cvIsExclusiveForMSE;

        if (IsExclusiveForMSE[index] == false)
            cvIsExclusiveForMSE = new CIMValue(Boolean.FALSE);
        else
            cvIsExclusiveForMSE = new CIMValue(Boolean.TRUE);

        return  cvIsExclusiveForMSE;
    }




    /**
     *  Method to return a vector of device object paths 
     */
    public Vector enumerateDevicePaths(CIMOMHandle cimomhandle)
    throws CIMException
    {
        IBMSG_DiagUtils utils = new IBMSG_DiagUtils(cimomhandle);
        utils.DEBUG_PRINT(logfile,"   In enumDevicePaths\n");

        //$$$ get instances of a LightPath adapter
        Enumeration e = cimomhandle.enumInstances(
                 new CIMObjectPath("CIM_SCSIController", namespace), CIMClient.DEEP);
        utils.DEBUG_PRINT(logfile,"      got CIM_TapeDrive object paths\n");

        // put the enumeration in a vector
        Vector dev_vect = new Vector();
        CIMObjectPath op = null;
        while (e.hasMoreElements())
        {
            op = (CIMObjectPath)e.nextElement();
            dev_vect.addElement(op);

            utils.DEBUG_PRINT(logfile,"      dev_vect is: "+dev_vect+"\n");
        }
        return dev_vect;
    }


   private static final String logfile = "ServeRAID Provider.log";


    /**
     *  Method to return a vector of device instances 
     */
    public Vector enumerateDevices(CIMOMHandle cimomhandle)
    throws CIMException
    {
        IBMSG_DiagUtils utils = new IBMSG_DiagUtils(cimomhandle);
        utils.DEBUG_PRINT(logfile,"   In enumDevicePaths\n");

        // /$$$ get instances of a LightPath adapter
        Enumeration e = cimomhandle.enumInstances(
                 new CIMObjectPath("CIM_SCSIController", namespace), CIMClient.DEEP, false);
        utils.DEBUG_PRINT(logfile,"      got CIM_TapeDrive object paths\n");

        // put the enumeration in a vector
        Vector dev_vect = new Vector();
        CIMInstance ci = null;
        while (e.hasMoreElements())
        {
            ci = (CIMInstance)e.nextElement();
            dev_vect.addElement(ci);

            utils.DEBUG_PRINT(logfile,"      dev_vect is: "+dev_vect+"\n");
        }
        return dev_vect;
    }


    /**
     *  Methods to get characteristics 
     *
     *  Characteristics - an enumeration of variables that represent the
     *                    DiagTest Propprities that are individual for each test
     *
     *  enum values = {"Unknown", "Other", "Is Exclusive", "Is Interactive",
     *                 "Is Destructive", "Is Risky", "Is Package",
     *                 "SupportsPercentOfTestCoverage"},
     */

    /**
     * is this test characteristic unknown 0x00
     */
    public Boolean getUnknown(int index)
    {
          Boolean isunk = Boolean.FALSE;
  
          for(int i = 0; Characteristics[index][i] != 0xFF; i++)
          {
              if (Characteristics[index][i] == 0x00)
              {
                  return isunk = Boolean.TRUE;
              }
          }
          return isunk;
    }




    /**
     * is this test an other characteristic 0x01
     */
    public Boolean getOther(int index)
    {
          Boolean isotherchar = Boolean.FALSE;
  
          for(int i = 0; Characteristics[index][i] != 0xFF; i++)
          {
              if (Characteristics[index][i] == 0x01)
              {
                  return isotherchar = Boolean.TRUE;
              }
          }
          return isotherchar;
    }




    /**
     * is this test exclusive 0x02
     */
    public Boolean getIsExclusive(int index)
    {
          Boolean isexclu = Boolean.FALSE;
  
          for(int i = 0; Characteristics[index][i] != 0xFF; i++)
          {
              if (Characteristics[index][i] == 0x02)
              {
                  return isexclu = Boolean.TRUE;
              }
          }
          return isexclu;
    }




    /**
     * is this test interactive 0x03
     */
    public Boolean getIsInteractive(int index)
    {
          Boolean isinteract = Boolean.FALSE;
  
          for(int i = 0; Characteristics[index][i] != 0xFF; i++)
          {
              if (Characteristics[index][i] == 0x03)
              {
                  return isinteract = Boolean.TRUE;
              }
          }
          return isinteract;
    }




    /**
     * is this test destructive 0x04
     */
    public Boolean getIsDestructive(int index)
    {
          Boolean isdestr = Boolean.FALSE;
  
          for(int i = 0; Characteristics[index][i] != 0xFF; i++)
          {
              if (Characteristics[index][i] == 0x04)
              {
                  return isdestr = Boolean.TRUE;
              }
          }
          return isdestr;
    }




    /**
     * is this test risky to run 0x05
     */
    public Boolean getIsRisky(int index)
    {
          Boolean isrky = Boolean.FALSE;
  
          for(int i = 0; Characteristics[index][i] != 0xFF; i++)
          {
              if (Characteristics[index][i] == 0x05)
              {
                  return isrky = Boolean.TRUE;
              }
          }
          return isrky;
    }




    /**
     * is this test a package 0x06
     */
    public Boolean getIsPackage(int index)
    {
          Boolean ispkg = Boolean.FALSE;
  
          for(int i = 0; Characteristics[index][i] != 0xFF; i++)
          {
              if (Characteristics[index][i] == 0x06)
              {
                  return ispkg = Boolean.TRUE;
              }
          }
          return ispkg;
    }



    /**
     *  does this test support percent of test coverage 0x07
     */
    public Boolean getSupportsPercentOfTestCoverage(int index)
    {
          Boolean testcov = Boolean.FALSE;
  
          for(int i = 0; Characteristics[index][i] != 0xFF; i++)
          {
              if (Characteristics[index][i] == 0x07)
              {
                  return testcov = Boolean.TRUE;
              }
          }
          return testcov;
    }




    /**
     *  The index to a test package is passed in and a Vector containing that package
     *  index and the indexs of the tests contained in the package are returned
     *
     *  A Vector with the first element of 0xFF indicates the index passed in was
     *  not a package
     */
    public Vector getTestPackage(int index)
    {
        Vector pkg = new Vector();
        int j, k = 0;
        boolean found = false;


        // is this a package test
        Boolean rc = getIsPackage(index);
        if (rc == Boolean.FALSE)
        {
            pkg.addElement(new UnsignedInt16(0xFF));
            return pkg;
        }

        // find the package contents
        for (j = 0; j < testPackages.length; j++)
        {
            if (testPackages[j][0] == index)
            {
                // found the package row element
                found = true;
                break;
            }
        }

        // couldn't find index in package array
        if (found == false)
        {
            pkg.addElement(new UnsignedInt16(0xFF));
            return pkg;
        }

        // put the test indexex in the Vector and return
        for (k = 0; k < testPackages[j].length; k++)
        {
            pkg.addElement(new UnsignedInt16(testPackages[j][k]));
        }

        return pkg;
    }




    /**
     *  The name to a test package is passed in and a Vector containing that package
     *  name and the names of the tests contained in the package are returned
     *
     *  A Vector with the first element of "not a pkg" indicates the name passed in was
     *  not a package
     */
    public Vector getTestPackageNames(String pkgname)
    {
        Vector pkg = new Vector();
        int j, k = 0;
        boolean found = false;
        int index = getTestIndex(pkgname);

        // is this a package test
        Boolean rc = getIsPackage(index);

        if (rc == Boolean.FALSE)
        {
            pkg.addElement("not a pkg");
            return pkg;
        }

        // find the package contents
        for (j = 0; j < testPackages.length; j++)
        {
            if (testPackages[j][0] == index)
            {
                // found the package row element
                found = true;
                break;
            }
        }

        // couldn't find index in package array
        if (found == false)
        {
            pkg.addElement(new UnsignedInt16(0xFF));
            return pkg;
        }

        // put the package name in the first element of the vector
        pkg.addElement(pkgname);

        // add the test names to the vector
        for (k = 1; k < testPackages[j].length; k++)
        {
            pkg.addElement(getTestName(testPackages[j][k]));
        }

        return pkg;
    }




    // is this test which is exclusive currently running?
    public boolean getExclusiveTestRunning(int index)
    {
        return exclusiveTestRunning[index];
    }


    
    /**
     * is this test which is exclusive to MSE currently ruuning on this MSE?
     *
     * if set to false return, if true check for MSE in list, if there return true 
     */
    public boolean getExclusiveTestToMSERunning(int index, String dut)
    {
        boolean rc = false;

        // is the test running?
        if (exclusiveTestToMSERunning[index] == false)
            return rc;
        else
        {
            // is it running on this MSE?
            int i = 0;
            for (i = 0; i < vDut[index].size(); i++)
            {
                if (dut.equalsIgnoreCase((String)vDut[index].elementAt(i)))
                    return rc = true;
            }
        }

        return rc;
    }




    public void setExclusiveTestRunning(int index, boolean b)
    {
        exclusiveTestRunning[index] = b;
    }


    
    /**
     *  This property say this test can only run on one MSE at a time. The value
     *  is set to true to say it is currently ruuning and the dut value is saved
     *  in a list (vector). 
     *
     *  set the exculsiveTestToMSE property as follows:
     *
     *  dut == "" - return an error
     *  b == true & dut has a value - set true and add dut to the list if not there
     *  b == false & dut has a value - set flase and remove from the list
     */
    public int setExclusiveTestToMSERunning(int index, String dut, boolean b)
    {
        int rc;

        if (dut == "")
            return rc = 3000;

        // set the boolean value to that passed in
        exclusiveTestToMSERunning[index] = b;

        // set the dut value, if blank erase if there, if not blank add in nor there
        int i = 0;
        if (b == true)
        {
            // search for dut, if found return
            for (i = 0; i < vDut[index].size(); i++)
            {
                if (dut.equalsIgnoreCase((String)vDut[index].elementAt(i)))
                    return rc = 0;
            }
            // dut not found so add to the list
            vDut[index].addElement(dut);
        }

        if (b == false)
        {
            // search for dut, if found remove from the list
            for (i = 0; i < vDut[index].size(); i++)
            {
                if (dut.equalsIgnoreCase((String)vDut[index].elementAt(i)))
                    vDut[index].removeElementAt(i);
            }
        }

              
        return rc = 0;
    }





    public void setStarted(int index, boolean s)
    {
        Started[index] = s;
    }





    public void setIsInUse(int index, boolean s)
    {
        IsInUse[index] = s;
    }
    



    public Vector getSettingSupport(int index)
    {
        Vector v = new Vector();

        for (int i = 0; i < settingArray.length; i++)
        {
            // add the setting property name to the vector
            v.addElement(settingArray[i][0]);
            // add the support value to the vector
            v.addElement(settingArray[i][index + 1]);
        }

        return v;
    }




    public Vector getSettingSupportNames(int index)
    {
        Vector v = new Vector();

        for (int i = 0; i < settingArray.length; i++)
        {
            if (settingArray[i][index + 1] != "null")
            {
                // add the setting property name to the vector
                v.addElement(settingArray[i][0]);
            }
        }

        return v;
    }




 

    // setting methods
    public CIMValue setQuickMode(int testindex, CIMValue cv)
    {
        if ((Boolean)cv.getValue() == Boolean.TRUE)
            QuickMode[testindex] = true;
        else 
        {
            if((Boolean)cv.getValue() == Boolean.FALSE)
                QuickMode[testindex] = false;
            else
                return new CIMValue(new UnsignedInt32(4000));
        } 
        
        return new CIMValue(new UnsignedInt32(0));
    }





    public boolean getQuickMode(int testindex)
    {
        return QuickMode[testindex];
    }





    public CIMValue setHaltOnError(int testindex, CIMValue cv)
    {
        if ((Boolean)cv.getValue() == Boolean.TRUE)
            HaltOnError[testindex] = true;
        else 
        {
            if((Boolean)cv.getValue() == Boolean.FALSE)
                HaltOnError[testindex] = false;
            else
                return new CIMValue(new UnsignedInt32(4000));
        } 
        
        return new CIMValue(new UnsignedInt32(0));

    }





    public boolean getHaltOnError(int testindex)
    {
        return HaltOnError[testindex];
    }





    public CIMValue setReportSoftErrors(int testindex, CIMValue cv)
    {
        if ((Boolean)cv.getValue() == Boolean.TRUE)
            ReportSoftErrors[testindex] = true;
        else 
        {
            if((Boolean)cv.getValue() == Boolean.FALSE)
                ReportSoftErrors[testindex] = false;
            else
                return new CIMValue(new UnsignedInt32(4000));
        } 
        
        return new CIMValue(new UnsignedInt32(0));

    }





    public boolean getReportSoftErrors(int testindex)
    {
        return ReportSoftErrors[testindex];
    }





    public CIMValue setReportStatusMessages(int testindex, CIMValue cv)
    {
        if ((Boolean)cv.getValue() == Boolean.TRUE)
            ReportStatusMessages[testindex] = true;
        else 
        {
            if((Boolean)cv.getValue() == Boolean.FALSE)
                ReportStatusMessages[testindex] = false;
            else
                return new CIMValue(new UnsignedInt32(4000));
        } 
        
        return new CIMValue(new UnsignedInt32(0));

    }





    public boolean getReportStatusMessages(int testindex)
    {
        return ReportStatusMessages[testindex];
    }




    
    public CIMValue setTestWarningLevel(int testindex, CIMValue cv)
    {
        TestWarningLevel[testindex] = ((Number)cv.getValue()).shortValue();
        return new CIMValue(new UnsignedInt32(0));
    }





    public short getTestWarningLevel(int testindex)
    {
        return TestWarningLevel[testindex];
    }





    public CIMValue setPercentOfTestCoverage(int testindex, CIMValue cv)
    {
        byte b = ((Number)cv.getValue()).byteValue();
        if (b <= 100)
        {
            PercentOfTestCoverage[testindex] = b;
            return new CIMValue(new UnsignedInt32(0));
        }
        else
            return new CIMValue(new UnsignedInt32(4040));
        
    }





    public byte getPercentOfTestCoverage(int testindex)
    {
        return PercentOfTestCoverage[testindex];
    }



   


    
//#### ToDo: methods to do with device(s) or type you support????






    /**
     *   PRIVATE DATA
     *
     *  The data in arrays IS ELEMENT POSITIONAL to corosponde with the tests.
     *
     *  Data that is a reflection of the MOF properties MUST be the same value as the MOF.
     */

    
    /**
     *  Name - the test case name for this instance of diag test
     *  These names are case sensitive as they are to be invoked
     *  MOF property defined in CIM_ManagedSystemeElement
     */
    //$$$ change to you r test case names, they ARE positional 
    private static final String[] Name =
    {
         //"IBM ServeRAID SCSI Controller Package Test",
         "serveRAIDInfo",
         "serveRAIDDMATest",
         "serveRAIDDriveSelfTest",
    };
    


    /**
     * Testpackages are defined in a multidimential array as follows:\
     *    int[x][y] testPackages where: x is a row representing a package,
     *        y is the test index of the package foolowed by the indexes of the 
     *        test included in the package
     *
     *    EX: int[][] testPackages = { {3,6,7}, {2,1,3,4}};
     *   
     *    contains 2 packages: one - test 3 is a package containing tests 6 and 7,
     *                         two - test 2 is a package containing tests 1, 3 and 4
     */
    //$$$ cahnge data only, if no packages then no data 
    private static final int[][] testPackages = 
    {
        
    };




    /**
     *  Caption - short description
     *  MOF property defined in CIM_ManagedSystemeElement
     */
    //$$$ change data (is positional with test case names)
    private static final String[] Caption =
    {
         "View status information",
         "Verify communication with NVRAM",
         "Determine status of drives in array",
    };

    


    /**
     * Description -  description of the diagnostic
     * MOF property defined in CIM_ManagedSystemeElement
     */
    //$$$ change data
    private static final String Description =  "Diagnostics for IBM ServeRAID SCSI Controllers";
    



    /**
     *  Status -  status for the device NOT the test
     *  string  values = {"OK", "Error", "Degraded", "Unknown", "Pred Fail", "Starting",
     *       Stopping", "Service", "Stressed", "NonRecover", "No Contact", "Lost Comm"}
     *
     *  MOF property defined in CIM_ManagedSystemeElement
     */
    private String Status = "Unknown";



    
    /**
     *  InstallDate - in the format YYYYMMDDhhmmss.SSSSSSsutc 
     *  MOF property defined in CIM_ManagedSystemeElement
     */
    //private CIMDateTime InstallDate = new CIMDateTime("20010814.000000-240");




    /**
     *  Started - indiactes whether the service has been started 
     *  MOF property defined in CIM_Service
     */
    //$$$ assure there is no more data than tests
    private boolean[] Started =
                 {false, false,false};
    



    /**
     *  StartMode - indicates how this service is started
     *  string values "Automatic" or "Manual" are the choices
     *  MOF property defined in CIM_Service
     */
    //$$$ change dataid needed
    private static final String StartMode = "Manual";

    

   

    /**
     *  IsInUse - is this test currently being executed
     *  MOF property defined in CIM_DiagnosticTest
     */
    //$$$ sata to match tests
    private boolean[] IsInUse = {false, false,false};



     
    /**
     *  Characteristics - an enumeration of variables that represent the
     *                    DiagTest Propprities that are individual for each test
     *
     *  enum values = {"Unknown", "Other", "Is Exclusive", "Is Interactive",
     *                 "Is Destructive", "Is Risky", "Is Package",
     *                 "Supports PercentOfTestCoverage","IsInformational"},
     *
     *  NOTE: Each element of the array covers a test. Within that element, list all
     *        the characteristics that apply. The enum ends when a value of 0xFF is reached.
     *        example: element = 2,5,0xFF  means this test has the characteristics
     *                                         "Is Exclusive" and "Is Risky"       
     *
     *        current valid values are: 0 - 8 
     *
     *  MOF property defined in CIM_DiagnosticTest
     */
    //$$$ change data
    private static final int[][] Characteristics = 
    {

        {0x08, 0xFF},
        {0x00, 0xFF},
        {0x00, 0xFF},
    };

     


    /**
     *  ResourcesUsed - system resources used to execute the diagnostic
     *
     *  enum values = {"CPU", "Memory", "Hard Diak", "CDROM", "Floopy", "PCI Bus",
     *                 "USB Bus", "IEEE 1394 Bus", "SCSI Bus", "IDE Bus", "ISA Bus",
     *                 "EISA Bus", "Vesa Bus", "PCMCIA Bus", "CardBus", "Access.Bus",
     *                 "NuBus", "AGP", "VME Bus", "Sbus IEEE 1396-1993", "MCA Bus",
     *                 "GIO Bus", "XIO  Bus", "HIO Bus", "PMC Bus", "SIO Bus", "Network"} 
     *
     *  see Characteristics example of how the enum works
     *
     *  current valid values are: 0 - 0x1A
     *
     *  MOF property defined in CIM_DiagnosticTest
     */
    //$$$ change data
    private static final int[][] ResourcesUsed =
    {
        //{0x06, 0x08, 0xFF},
        {0x06, 0x08, 0xFF},
        {0x06, 0x08, 0xFF},
        {0x06, 0x08, 0xFF},
    };




    /**
     *  OtherCharacteristicDescription - provides additional information and is valid
     *                                   only when Characteristics is set to "Other"        
     *  MOF property defined in CIM_DiagnosticTest
     */
    //$$$ data
    private static final String[] OtherCharacteristicDescription = 
         {"", "",""};
    



    /**
     * private variables for ServeRAID used in the DiagTestForMSE association
     */
    //$$$ data
    private static final int[] EstimatedTimeOfPerforming = {0, 0, 0};

    //$$$ data
    private static final boolean[] IsExclusiveForMSE = 
             {false, false, false};



    /**
     * private variable to indicate if a test that is exclusive is running
     */
    //$$$ data
    private boolean[] exclusiveTestRunning = { false, false, false};


    /** 
     * private variable to indiacte if a test that is exclusive to MSE is runnning
     */
    //$$$ data
    private boolean[] exclusiveTestToMSERunning =
                                        {false, false, false};

    /**
     * private variable to be use with exclusive to MSE to hold dut
     */
    //$$$ data
    private Vector[] vDut = {new Vector(), new Vector(), new Vector()};
    


    /**
     * private data for the test settings
     * There is one element per test with the element format being:
     * { setting property  name,
     *   for test index 0 - null means not supported - anything else is the default,
     *   for test index 1 - null means not supported - anything else is the default,
     * ......,
     *   for test index n - null means not supported - anything else is the default) 
     *
     * for example: {quick mode, null, true , false, null};
     * means test 0 does not support this setting, test 1 does with a default of true,
     *       test 2 does support it with a default of false, test 3 does not suppoet it}
     *
     * NOTE: "support it" means the users can change this setting  
     */
    private String[][] settingArray =
    {
        {            "QuickMode", "null",  "null",  "null",},
        {          "HaltOnError", "null",  "null",  "null",},
        {     "ReportSoftErrors", "null",  "null",  "null",},
        { "ReportStatusMessages", "null",  "null",  "null",},
        {     "TestWarningLevel", "null",  "null",  "null",},
        {"PercentOfTestCoverage",  "100",  "null",  "null",}
    };
    



    // private variables to hold the setting values
    private boolean[] QuickMode = {false, false, false};      

    private boolean[] HaltOnError = {false, false, false,};

    private boolean[] ReportSoftErrors = {false, false, false,};

    private boolean[] ReportStatusMessages = {false, false, false,};

    private short[] TestWarningLevel = {0x0000, 0x0000, 0x0000,};

    private byte[] PercentOfTestCoverage = {100, 100, 100};


}

