/**
 * Description:  
 * Copyright:    Copyright (c) 2001
 * Company:      IBM
 * Date:  Jan 15, 2003 
 * @author Rodney H. Brown
 * Path, component, release: %W%
 * @version                : %I%
 * Extracted at            : %T% on %H%
 * Newest delta applied at : %U% on %G%
 * Notes:
 *  
 * Change History:
 *   Date:                      Intials/Defect          Change:
 */
package com.ibm.sysmgt.raidmgr.cim.provider.cdm;

import java.util.Hashtable;


/**
*
*   File:   FRU.java
*   Desc:   FRUP is the interface that provides information 
*   about the FRU for the planar, SCSI, and RAIDAdapter of supported systems.
*
*
*
*   @author Jodie M. Wilder
*   @version 1.1, September 13, 2001
*
*
* 
**/
public class ServeRAIDFRU extends Hashtable
{
   private static ServeRAIDFRU fru;

   public static ServeRAIDFRU getFRUObject()
   {
      if (fru == null)
      {
         fru = new ServeRAIDFRU();
         return fru;
      }
      else
         return fru;
   }

   private ServeRAIDFRU()
   {
      /**
      *
      *   This is the Hashtable that holds the FRU numbers for the different
      *   RAIDAdapter devices that are supported.
      *
      **/
      super.put("3H", "01K7396");
      super.put("3L", "01K7207");
      super.put("3HB", "37L6086");
      super.put("4Mx", "06P5736");
      super.put("4Lx", "06P5740");
      super.put("4M", "37L7258");
      super.put("4L", "09N9540");
      super.put("4H", "37L6892");

      /**This is the FRU for the Falcon SP
      **/
      super.put("Falcon", "36L9912"); //Falcon
   }

   public String getFRU(String key)
   {
      return(String) super.get(key);
   }
}
