/**
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      IBM
 *
 *
 * @author Rodney H. Brown
 * Path, component, release: prov/com/ibm/providers/ServeRAID/ServeRAID_AdapterDMATest.java, sv_esw_cdm_provider, raid_prov, 20021101
 * Version                 : 1.1
 * Extracted at            : 10:44:50 on 11/12/02
 * Newest delta applied at : 15:17:16 on 4/2/02
 * Notes:
 *  
 * Change History:
 *   Date:			Intials:		Change:
 *			       
 */

//$$$ change package name to provider package name       
package com.ibm.sysmgt.raidmgr.cim.provider.cdm;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.MissingResourceException;
import java.util.ResourceBundle;
import java.util.Vector;



/** 
 * <P> Implementation of the DMA test for the ServeRAID Adapter subclasses from ServeRAIDTest class </P>
 */
public class ServeRAID_AdapterDMATest extends ServeRAIDTest
{

    public static final int TEST_ADAPTERDMA = 1;

    /**
     *<P>Default constructor.</P>
     */
    public ServeRAID_AdapterDMATest(String _deviceID, ResourceBundle resourceBundle, Results result) throws Exception
    {
	super(_deviceID, resourceBundle,result);
	testIndex = TEST_ADAPTERDMA;
    }



    /**
     *<P> Gets the details of the last test execution.</P>
     * @throws MissingResourceException
     * @throws Exception
     */
    public Vector getTestDetails() throws MissingResourceException, Exception
    {
	try
	{
	    
	    if(testResult.statusCode != testResult.RESULT_STOPPED)
	    {
		for(Enumeration propertyEnum = serveRAIDAdapterInfo.formatAdapterProperties(resourceBundle,false).elements();
		    propertyEnum.hasMoreElements();)
		{
		    testResult.details.addElement(propertyEnum.nextElement());
		}

		if(testResult.statusCode == testResult.RESULT_FAILED)
		{
		    //Gather Adapter FRU information and tack it on the end of the Details array...
		    String adapterModelCode   = (String) serveRAIDAdapterInfo.getAdapterProperty(serveRAIDAdapterInfo.OFFSET_ADAPTER_MODEL);
		    String adapterModelString = resourceBundle.getString("AdapterModel."+adapterModelCode);
		    testResult.details.addElement(resourceBundle.getString("AdapterFruNumber") +
						      ServeRAIDFRU.getFRUObject().getFRU(adapterModelString.trim()));
		}
	    }
	    
	}
	catch(MissingResourceException resourceMissing)
	{
	    throw resourceMissing;
	}
	catch(Exception anyException)
	{
	    throw anyException;
	}

	return testResult.details;
    }




    /**
     *<P> Gets the actions for the failures detected by the last test execution.</P>
     * @throws MissingResourceException
     * @throws Exception     
     */
    public Vector getActionOnFailure() throws MissingResourceException, Exception
    {
	try
	{
	    
	    if(testResult.statusCode == testResult.RESULT_FAILED)
	    {
    
		testResult.actionOnFailure.addElement(resourceBundle.getString("ActionItem.adapter.reboot_system"));
		testResult.actionOnFailure.addElement(resourceBundle.getString("ActionItem.adapter.change_slot"));
		testResult.actionOnFailure.addElement(resourceBundle.getString("ActionItem.adapter.check_cables"));
		testResult.actionOnFailure.addElement(resourceBundle.getString("ActionItem.adapter.update_firmware"));
		testResult.actionOnFailure.addElement(resourceBundle.getString("ActionItem.adapter.update_bios"));
		testResult.actionOnFailure.addElement(resourceBundle.getString("ActionItem.adapter.reboot_check_post"));
		testResult.actionOnFailure.addElement(resourceBundle.getString("ActionItem.adapter.call_service"));

    
	    }
	}
	catch(MissingResourceException resourceMissing)
	{
	    throw resourceMissing;
	}
	catch(Exception anyException)
	{
	    throw anyException;
	}

	return testResult.actionOnFailure;
    }
    
}
