package com.ibm.sysmgt.raidmgr.cim.provider.v2;

import java.io.*;
import java.util.*;
import java.rmi.*;
import com.ibm.sysmgt.raidmgr.*;
import com.ibm.sysmgt.raidmgr.util.*;
import com.ibm.sysmgt.raidmgr.dataproc.*;
import com.ibm.sysmgt.raidmgr.twg.TaskEnvironmentTWG;
import com.tivoli.twg.libs.*;

public class ManagementAgentIPC implements com.ibm.sysmgt.raidmgr.agent.ManagementAgentIntf
{
   private IPCDataProcProxy dataProcProxy = null;
  
   private PrintWriter log;

   /**
     * Constructor to create the ManagementAgentRemote
     * @param the log file reference used for error logging
     */
   public ManagementAgentIPC( PrintWriter log )
   {
      ServiceNodeLocalImplFactory snlif = new ServiceNodeLocalImplFactory();
      ServiceNode.SetServiceNodeFactory(snlif);
      this.log = log;
      createDataProcProxy();
   }  

   private DataProcIntf createDataProcProxy()
   {
      try
      {
         dataProcProxy = new IPCDataProcProxy(DP.RAID_SVCNODE_NAME, false, null);
      }
      catch (ServiceNodeException tivE)
      {
          System.out.println(tivE);
          log.println("Unable to create dataProcProxy.");
          tivE.printStackTrace(log);
      }
      return dataProcProxy;
   }

   public DataProcIntf getDataProcessor()
   {
      return dataProcProxy;
   }

   public Vector getInitialEvents() throws RemoteException
   {
      return dataProcProxy.getEvents(true);
   }   

   public Vector getEvents() throws RemoteException
   {
       return dataProcProxy.getEvents(false);
   }
}
