package com.ibm.sysmgt.raidmgr.mgtGUI.plaf;

import javax.swing.UIDefaults;

public class PlatformInstantiator implements UIDefaults.LazyValue
{
  /**
   * Registers LazyValues necessary to work around
   * bug #4155617 ("PlugIn can not load custom UI components")
   */ 
  
  static public void putInstantiators(UIDefaults table,String[] classes) 
  {
    int length = classes.length;
    int i;
    Object[] instantiators = new Object[2*length];
    for (i = 0; i < length; i++)
    {
      String name = classes[i];
      instantiators[2*i] = name;
      instantiators[2*i + 1] = new PlatformInstantiator(name);
    }

    table.putDefaults(instantiators);
  }
    
  public PlatformInstantiator(String className) 
  {
    _className = className;
  }

  public Object createValue(UIDefaults table) {
    Class uiClass;
    try
    {
      uiClass = Class.forName(_className);
    }
    catch (ClassNotFoundException e)
    {
      return null;
    }
    return uiClass;
  }
  private String  _className;
}


